var debug = false; // debug the build script

var doBuild = true; // true = build the program
                    // false = write a build script
var linkOnly = false; // true = don't compile, just link and post-process
                      // false = compile and build
var quiet = false;  
var verbose = false; // not a command line option
var stopEarly = false;
var globalDefines = '';
var startAt = '';

/*
runMake
  doConfigure
    runCommand

  doCompile
    compileFile
      runCommand

  doLink
    runCommand

  doConfigure
    runCommand

*/
function objMatches(a,platform,mode)
{
  //var ret = ((!a.get('platform') || a.get('platform') == (platform?platform.get('name'):'')) && 
  //        (!a.get('mode') || a.get('mode') == (mode?mode.get('name'):'')));

  return ((!a.get('platform') || a.get('platform').split(',').indexOf(platform?platform.get('name'):'')!= -1) && 
          (!a.get('mode') || a.get('mode').split(',').indexOf(mode?mode.get('name'):'')!= -1));
  /*
  if (platform && a.get('platform'))
  {
   if (a.get('platform').split(',').indexOf(platform.get('name')) == -1) return false
  }
  if (mode && a.get('mode'))
  {
   if (a.get('mode').split(',').indexOf(mode.get('name')) == -1) return false
  }
  return true;
  */
}

function getProperty(name,node,platform,mode,delimiter)
{
   var d = '';
   if (delimiter == null) delimiter = '';
   var l = node.find(name);
   for (var i in l)
   { 
       if (objMatches(l[i],platform,mode))
         d += l[i].cdata+delimiter ;
   }
   return d;
}

function getAttribute(name,node,delimiter)
{
   var l = node.get(name);
   if (delimiter == null) delimiter = '';
   if (l) return l+delimiter;
   return '';
}
     
//BCC Error E2285 rs/tbl_main.cpp 78: Message
//gcc filename:error:line: description
function scanErrors(msgs,errors)
{
 var l;
 while(l=msgs.readln())
 {  
  if (l.indexOf("Error") == 0) //Borland C++
   return false;
  
  if (l.indexOf('error:') != -1) //gcc
   return false;

  if ((l.indexOf('g++.exe') == 0 || l.indexOf('gcc.exe:') == 0) && l.indexOf('warning:') == -1) //gcc
   return false;
  
  //skip "in file included from ..." notes before warnings.
  if (l.search(/^[\w/]+\:\d+\:/) >= 0 && l.indexOf("warning") != -1) //gcc
   return false;
  
  if (l.indexOf("(.text") >= 0) //gcc link
   return false;  
 }
 return true;
}

function runCommand(cmd,errors)
{
   if (verbose) writeln(cmd);
   if (cmd.substr(0,2) == '#!') return true;
   var w = cmd.match(/[^ "]+|"[^"]*"/g);
   for (var x =0; x<w.length; x++) w[x] = w[x].replace(/^"|"$/g,'')
   if (w[0] == 'cp' || w[0] == 'copy')
   {
    system.copy(w[1],w[2])
    return true;
   }
   if (w[0] == 'mv' || w[0] == 'move')
   {
    system.move(w[1],w[2],true)
    return true;
   }
   if (w[0] == 'echo')
   {
    writeln(cmd.replace(/^echo/,''));
    return true;
   }
   var msgs = new Stream;
   var out 
   if (cmd.indexOf('>') != -1)
   {
     var append = cmd.indexOf('>>') != -1;
     cmd = cmd.split(/>+/)
     out = new Stream(cmd[1].replace(/^\s+/,''),append ? 'at' : 'wt')
     cmd = cmd[0].replace(/^\.\//,'').replace(/\s+$/,'')
   }
   var pc = new Stream('exec://'+cmd);  
   var se = pc.stderr;
   while (pc.canRead || pc.canWrite)
     {
      sleep(10);
      while (se.canRead)
      {
       var c = se.read(1);
       if (verbose) write(c);
       msgs.write(c);
      }
      while (pc.canRead)
      {
       var c = pc.read(1);
       if (!c) continue;
       if (verbose) write(c);
       if (out) out.write(c)
       else msgs.write(c);
      }
     }
   pc.close();
   if (out) out.close()
   msgs.rewind();
   if (!scanErrors(msgs)) //returns false on error
    {
     msgs.rewind();
     errors.writeln(cmd);
     errors.append(msgs);
     return false;
    }
   return true;
}

function rejoin(template,array)
{
 var s = '';
 for (var a in array) if (array[a]) s += template.replace(/\$value/g,array[a]);
 return s;
}

function compileFile(cmds,compiler,target,platform,mode,group,file,run)
{
  var define = globalDefines;
      define += getProperty('define',mode,platform,null,';');
      define += getProperty('define',platform,null,mode,';');
      define += getProperty('define',target,platform,mode,';');
      define += getProperty('define',group,platform,mode,';');
      define += getProperty('define',file,platform,mode,';');
      define += getProperty('define',compiler,platform,mode,';');

  var include = group.get('path');
      if (include) include += ';';
      include +=  getAttribute('include',mode,';');
      include += getAttribute('include',platform,';');
      include += getAttribute('include',group,';');
      include += getAttribute('include',file,';');
         
  var cmd = compiler.get('path');
  var params = compiler.get('parameters');
  var infile = group.get('path') + file.cdata;  
  var outfile = file.cdata.replace(/\.\w*$/,compiler.get('output')).replace(/[\/\ \\]/g,'_');
  
  var options = getProperty('options',compiler,platform,mode,' ');
  
  var templates = compiler.find('template','name','define');
  if (templates.length)
  {
    define = rejoin(templates[0].cdata,define.split(';'))
  }
  
  templates = compiler.find('template','name','include');
  if (templates.length)
  {
    include = rejoin(templates[0].cdata,include.split(';'))
  }
  
  params = params.replace(/\$input/g,infile);
  params = params.replace(/\$output/g,outfile);
  params = params.replace(/\$options/g,options);
  params = params.replace(/\$define/g,define);
  params = params.replace(/\$include/g,include);
  params = params.replace(/\$intermediate/g,target.get('intermediate'));
  
  if (run)
  {
    if (doBuild)
    { 
        writeln(file.cdata);
       if (!runCommand(cmd + ' ' + params,cmds)) 
          throw(file.cdata); //+'\r\n'+cmd+' '+params);   
    }
    else
    {
     cmds.writeln(cmd + ' ' + params);  
    }
  }
  return outfile;
}

function doConfigure(commands,configure,platform,mode)
{
 try 
 {
  for (var i in configure)
  {
    if (objMatches(configure[i],platform,mode)) 
    {
      var cmd = configure[i].cdata;
      if (doBuild)
      { 
        writeln(cmd);
        if (!runCommand(cmd,commands)) 
           throw(cmd); //+'\r\n'+cmd+' '+params);
      }
      else
      {
        commands.writeln(cmd);  
      }    
    }
  }
 } catch(err)
 {
   writeln(err)
   return false
 }
}
//defines and includes are additive options

function doCompile(cmds,project,target,platform,mode,filters)
{
  var defaultCompiler = platform.find('compile')[0];
  
  var objFiles = [];
  
  var gnames = target.find('group');
  var groups = [target]; //include top-level <file> tags
  var i, j, files, filename, type, compiler;

  for (i in gnames)
   groups = groups.concat(project.find('group','name',gnames[i].cdata));
  
  for (i in groups)
  {
    if (objMatches(groups[i],platform,mode))
    {
      files = groups[i].find('file');
      for (j in files)
      {
        filename = files[j].cdata;
        var run = false;
        
        if (filters.length)
        {
         for each(filter in filters)
         {
          if (filter.indexOf('*') != -1)
          {
           if (filename.match(new RegExp('^' + filter.replace(/\*/g,'.*'))))
             run = true;
          }
          else if (filename.toUpperCase().search(filter.toUpperCase()) != -1)
          {
           run = true;
           break;
          }
         }
        }
        else run = !linkOnly;

        if (objMatches(files[j],platform,mode))
        {
          type = filename.substr(filename.lastIndexOf('.'));
          compiler = platform.find('compile','input',type)[0];
          if (!compiler) compiler = defaultCompiler;
        
          if (startAt)
          {
           if (filename == startAt)
             startAt = '';
           else
           {           
             objFiles.push(filename.replace(/\.\w*$/,compiler.get('output')));
             continue;
           }
          }
          
          objFiles.push(compileFile(cmds,compiler,target,platform,mode,groups[i],files[j],run));
        }             
      }
     }
  } 
  return objFiles;
}

function findFile(target,linker,file)
{
 if (!linker.get('resolve')) return file;
 return target.get('intermediate')+file;
 return file;
}

function doLink(cmds,objFiles,target,platform,mode)
{
  //link step

  var linker = platform.find('link','mode',mode)[0];
  if (!linker) linker = platform.find('link')[0];  
  var cmd = linker.get('path');
  var params = linker.get('parameters');
  var infiles = ''; 
  var rfiles = '';
  for (var i in objFiles) 
   { 
     if (objFiles[i].indexOf('.o') > 0) infiles += findFile(target,linker,objFiles[i])+' ';
     else rfiles += findFile(target,linker,objFiles[i]) + ' ';
    }
  var options = getProperty('options',linker,platform,mode,' ');
  
  //<link parameters="$options, C0X32 $input,$output,$mapfile,IMPORT32 CW32MT,$deffile " >
  //<target platform=win32 output="jsdb.exe" mapfile="jsdb.map" deffile="jsdb.def" intermediate="obj\">

  var libraries = target.get('libraries');

  var templates = linker.find('template','name','library');
  if (templates.length)
  {
      libraries = rejoin(templates[0].cdata,libraries.split(';'))
  }
  params = params.replace(/\$input/g,infiles);
  params = params.replace(/\$resource/g,rfiles);
  params = params.replace(/\$output/g,target.get('output'));
  params = params.replace(/\$mapfile/g,target.get('mapfile'));
  params = params.replace(/\$deffile/g,target.get('deffile'));
  params = params.replace(/\$libraries/g,libraries);
  params = params.replace(/\$options/g,options);  
  params = params.replace(/\$intermediate/g,target.get('intermediate'));
  
  if (doBuild)
  { 
    writeln(target.get('output'));
    if (!runCommand(cmd + ' ' + params,cmds)) 
      throw(target.get('output')+'\r\n'+cmd+' '+params);
  }
  else
  {
    cmds.writeln(cmd + ' ' + params); 
  }
}

function runMake(project,platform)
{ 
 var targetNames = [];
 var mode = null; 
 var filters = [];
 
 var msg = ''
 var error = null

 while (system.arguments.length)
 { 
   var p = system.arguments.shift()
   if (p.toLowerCase() == '/preview')
     doBuild = false;
   else if (p.toLowerCase() == '/quiet')
     quiet = true;
   else if (p.toLowerCase() == '/link')
     linkOnly = true;
   else if (p.toLowerCase() == '/verbose')
     verbose = true;
   else if (p.toLowerCase() == '/stopwarn')
     stopEarly = true;
   else if (p.toLowerCase() == '/resume')
   {
     var x = new Stream("make.log")
     startAt = x.readLine()
     x.close()
   }
   else if (p == '/define') 
   {
    globalDefines = system.arguments.shift() + ';'
   }
   else if (p[0] == '/') 
   {
    var x = project.find('mode','name',p.substr(1));
    if (!mode && x.length)
      mode = x[0];
   }
   else 
   {
    var x = project.find('target','name',p);
    if (x.length) 
    {
     targetNames.push(p);
     msg += "Targeting " + p;
    }
    else
    {
     filters.push(p);
     msg += "Compiling *" + p + "* ";
    }
   }
   // else other flags     
 }

 if (doBuild) writeln(msg)
 if (!mode) mode = project.find('mode')[0];
 
 var targets = project.find('target');

 if (doBuild) writeln('Building ',project.get('name'),' for ',platform.get('name'));
 
 var commands = new Stream; 
 
 if (debug) writeln(1)
 // run global and platform-dependent configure scripts
 
 if (!linkOnly && filters.length == 0)
 {
  doConfigure(commands,platform.find('configure'),null,mode);
  doConfigure(commands,project.find('configure'),platform,mode);
 }

 // look over potential targets
 try {
 for (var i in targets)
  {
   if (targetNames.length && targetNames.indexOf(targets[i].get('name')) == -1) continue;

   if (objMatches(targets[i],platform,mode)) 
   {
     if (doBuild) 
     { 
       writeln('Target: ',targets[i].get('name'))
       writeln('Platform: ',platform.get('name'))
       writeln('Output: ',targets[i].get('output'))
       writeln('Mode: ',mode.get('name'))
     }
     if (!linkOnly)
      doConfigure(commands,targets[i].find('configure'),platform,mode);

     var objs = doCompile(commands,project,targets[i],platform,mode,filters);
     
     if (linkOnly || filters.length == 0) // don't link if we're just filtering
     {
      doLink(commands,objs,targets[i],platform,mode);
     }
   }
  } 
 } catch(err) 
 {
  error = (err)   
  writeln("Error in ", err); 
 }

 // run platform-dependent configure scripts if linking (no compile filters)
 if (filters.length == 0)
 {
  doConfigure(commands,platform.find('finish'),null,mode);
  doConfigure(commands,project.find('finish'),platform,mode);
 }
 // done!
 if (!quiet)
 {
   commands.rewind();
   write(commands);
 }
 commands.rewind();
 log = new Stream('make.log','wt');
 if (error) log.writeln(error)
 log.append(commands);
}

var help = "Usage: jsdb make.js jsdb.project platform [target ...] [file ...] [/debug] [/preview] [/quiet] [/verbose] [/stopwarn] [/link] [/resume] [/define ...]"
if (typeof(system.arguments) == 'undefined' || system.arguments.length == 0)
{
  writeln(help)
}
else
{
 load('xml.js')

 var projectName = system.arguments.shift()
 if (projectName.indexOf(".project") == -1 && system.exists(projectName+ '.project')) 
     projectName += ".project"
// writeln(projectName)

 var project = XML.read(new Stream(projectName),'target,project,mode,configure,finish,define,compile,link,group,file,platform,options,template');

 var platformName = '' //project.get('platform')

 if (system.arguments.length)
   platformName = system.arguments.shift()
   
 if (platformName)
 {
   var platform = project.find('platform','name',platformName)[0];
   if (platform) 
     runMake(project,platform)
   else
     writeln("Unknown platform: ",platform)
 }
 else
 {
  writeln(help) 

  writeln("Platforms")
  var l = project.find('platform');
  for (var i in l) writeln(" ",l[i].get('name'));
  
  writeln("Modes")
  var l = project.find('mode');
  for (var i in l) writeln(" ",l[i].get('name'));
  
  writeln("Targets")
  var l = project.find('target');
  for (var i in l) writeln(" ",l[i].get('name'),": ",l[i].get('output')," (",l[i].get('platform'),")");
 }
}
